function rev(points)
%% rev(points)
%% points are N by 2 
%% nCluster = 16 <= N
%% instead of doing clustering with N points without structure, 
%% as in vq.m, we use the information that we want the cluster
%% to be as grid by rotate([-3 -1 1 3]^2), and estimate the 
%% rotation

nCluster = 16;
N = size(points, 1);
mu = 0.01;

pos = [1 1; 1 3; 3 1; 3 3; ...
       -1 -1; -1 -3; -3 -1; -3 -3; ...
       1 -1; 1 -3; 3 -1; 3 -3; ...
       -1 1; -1 3; -3 1; -3 3];
pt = [0.1, 0.1];
w = pos * diag(pt);

for k=1:10000
  i = floor(rand(1) * N) + 1;
  diff = w - ones(nCluster, 1) * points(i, :);
  [m, proto] = min(diff(:, 1) .^ 2 + diff(:, 2) .^ 2);
  ww = w(proto, :) + mu * (points(i, :) - w(proto, :));
  pp = pos(proto, :);
  
  tmp = (pos(:, 1) + pos(:, 2) * j) * (ww(1) + ww(2) * j) ./ (pp(1) + pp(2) * j);
  w(:, 1) = real(tmp);
  w(:, 2) = imag(tmp);

  pt = w(1, :);

  if mod(k, 100) == 1
    plot(points(:, 1), points(:, 2), 'r.');
    hold on;
    plot(w(:, 1), w(:, 2), 'go');
    hold off;
    drawnow;
  end  
end


  
